# coding: utf-8

"""
    SMTP Public API overview

    SMTP.com Public API v4  # noqa: E501

    The version of the OpenAPI document: 4.0.0
    Contact: support@smtp.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from smtpcom.configuration import Configuration


class ReportsDataOndemand(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'status': 'str',
        'name': 'str',
        'url': 'str',
        'time_req': 'int',
        'progress': 'int',
        'channel': 'str',
        'report_id': 'str'
    }

    attribute_map = {
        'status': 'status',
        'name': 'name',
        'url': 'url',
        'time_req': 'time_req',
        'progress': 'progress',
        'channel': 'channel',
        'report_id': 'report_id'
    }

    def __init__(self, status=None, name=None, url=None, time_req=None, progress=None, channel=None, report_id=None, local_vars_configuration=None):  # noqa: E501
        """ReportsDataOndemand - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._status = None
        self._name = None
        self._url = None
        self._time_req = None
        self._progress = None
        self._channel = None
        self._report_id = None
        self.discriminator = None

        if status is not None:
            self.status = status
        if name is not None:
            self.name = name
        if url is not None:
            self.url = url
        if time_req is not None:
            self.time_req = time_req
        if progress is not None:
            self.progress = progress
        if channel is not None:
            self.channel = channel
        if report_id is not None:
            self.report_id = report_id

    @property
    def status(self):
        """Gets the status of this ReportsDataOndemand.  # noqa: E501

        Current status of a given on-demand report  # noqa: E501

        :return: The status of this ReportsDataOndemand.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this ReportsDataOndemand.

        Current status of a given on-demand report  # noqa: E501

        :param status: The status of this ReportsDataOndemand.  # noqa: E501
        :type status: str
        """
        allowed_values = ["in_progress", "done", "pending"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and status not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def name(self):
        """Gets the name of this ReportsDataOndemand.  # noqa: E501

        Human readable name of an on-demand report (auto-generated)  # noqa: E501

        :return: The name of this ReportsDataOndemand.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ReportsDataOndemand.

        Human readable name of an on-demand report (auto-generated)  # noqa: E501

        :param name: The name of this ReportsDataOndemand.  # noqa: E501
        :type name: str
        """

        self._name = name

    @property
    def url(self):
        """Gets the url of this ReportsDataOndemand.  # noqa: E501

        The unique URL from which to download an on-demand report  # noqa: E501

        :return: The url of this ReportsDataOndemand.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this ReportsDataOndemand.

        The unique URL from which to download an on-demand report  # noqa: E501

        :param url: The url of this ReportsDataOndemand.  # noqa: E501
        :type url: str
        """

        self._url = url

    @property
    def time_req(self):
        """Gets the time_req of this ReportsDataOndemand.  # noqa: E501

        Time when a given on-demand report has been requestedi. RFC 2822 or UNIX epoch format  # noqa: E501

        :return: The time_req of this ReportsDataOndemand.  # noqa: E501
        :rtype: int
        """
        return self._time_req

    @time_req.setter
    def time_req(self, time_req):
        """Sets the time_req of this ReportsDataOndemand.

        Time when a given on-demand report has been requestedi. RFC 2822 or UNIX epoch format  # noqa: E501

        :param time_req: The time_req of this ReportsDataOndemand.  # noqa: E501
        :type time_req: int
        """

        self._time_req = time_req

    @property
    def progress(self):
        """Gets the progress of this ReportsDataOndemand.  # noqa: E501

        Percentage of completion for an on-demand report  # noqa: E501

        :return: The progress of this ReportsDataOndemand.  # noqa: E501
        :rtype: int
        """
        return self._progress

    @progress.setter
    def progress(self, progress):
        """Sets the progress of this ReportsDataOndemand.

        Percentage of completion for an on-demand report  # noqa: E501

        :param progress: The progress of this ReportsDataOndemand.  # noqa: E501
        :type progress: int
        """

        self._progress = progress

    @property
    def channel(self):
        """Gets the channel of this ReportsDataOndemand.  # noqa: E501

        Name of the channel for which a given report has been defined  # noqa: E501

        :return: The channel of this ReportsDataOndemand.  # noqa: E501
        :rtype: str
        """
        return self._channel

    @channel.setter
    def channel(self, channel):
        """Sets the channel of this ReportsDataOndemand.

        Name of the channel for which a given report has been defined  # noqa: E501

        :param channel: The channel of this ReportsDataOndemand.  # noqa: E501
        :type channel: str
        """

        self._channel = channel

    @property
    def report_id(self):
        """Gets the report_id of this ReportsDataOndemand.  # noqa: E501

        Unique report ID  # noqa: E501

        :return: The report_id of this ReportsDataOndemand.  # noqa: E501
        :rtype: str
        """
        return self._report_id

    @report_id.setter
    def report_id(self, report_id):
        """Sets the report_id of this ReportsDataOndemand.

        Unique report ID  # noqa: E501

        :param report_id: The report_id of this ReportsDataOndemand.  # noqa: E501
        :type report_id: str
        """

        self._report_id = report_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ReportsDataOndemand):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ReportsDataOndemand):
            return True

        return self.to_dict() != other.to_dict()
